Needed to make %G output "DEFAULT" when gid == GID_NONE.
[rsync/rsync.git] / runtests.sh
CommitLineData
e7d29902
MP
1#! /bin/sh
2
cf72f204 3# Copyright (C) 2001, 2002 by Martin Pool <mbp@samba.org>
e7d29902
MP
4
5# This program is free software; you can redistribute it and/or modify
a4cf6bec
MP
6# it under the terms of the GNU General Public License version
7# 2 as published by the Free Software Foundation.
e7d29902
MP
8#
9# This program is distributed in the hope that it will be useful, but
10# WITHOUT ANY WARRANTY; without even the implied warranty of
11# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
12# Lesser General Public License for more details.
13#
14# You should have received a copy of the GNU Lesser General Public
15# License along with this program; if not, write to the Free Software
16# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
17
18
19# rsync top-level test script -- this invokes all the other more
20# detailed tests in order. This script can either be called by `make
21# check' or `make installcheck'. `check' runs against the copies of
22# the program and other files in the build directory, and
23# `installcheck' against the installed copy of the program.
24
25# In either case we need to also be able to find the source directory,
26# since we read test scripts and possibly other information from
27# there.
28
29# Whenever possible, informational messages are written to stdout and
30# error messages to stderr. They're separated out by the build farm
31# display scripts.
32
33# According to the GNU autoconf manual, the only valid place to set up
34# directory locations is through Make, since users are allowed to (try
35# to) change their mind on the Make command line. So, Make has to
36# pass in all the values we need.
37
38# For other configured settings we read ./config.sh, which tells us
39# about shell commands on this machine and similar things.
40
41# rsync_bin gives the location of the rsync binary. This is either
42# builddir/rsync if we're testing an uninstalled copy, or
43# install_prefix/bin/rsync if we're testing an installed copy. On the
44# build farm rsync will be installed, but into a scratch /usr.
45
46# srcdir gives the location of the source tree, which lets us find the
47# build scripts. At the moment we assume we are invoked from the
48# source directory.
49
50# This script must be invoked from the build directory.
51
52# A scratch directory, 'testtmp', is created in the build directory to
53# hold working files.
54
3a4c683f
MP
55# This script also uses the $loglevel environment variable. 1 is the
56# default value, and 10 the most verbose. You can set this from the
57# Make command line. It's also set by the build farm to give more
58# detail for failing builds.
59
60
61# NOTES FOR TEST CASES:
62
63# Each test case runs in its own shell.
e7d29902 64
12b9c840 65# Exit codes from tests:
e7d29902
MP
66
67# 1 tests failed
68# 2 error in starting tests
3a4c683f
MP
69# 77 this test skipped (random value unlikely to happen by chance, same as
70# automake)
71
12b9c840
MP
72# HOWEVER, the overall exit code to the farm is different: we return
73# the *number of tests that failed*, so that it will show up nicely in
74# the overall summary.
75
3a4c683f
MP
76# rsync.fns contains some general setup functions and definitions.
77
78
79# NOTES ON PORTABILITY:
80
81# Both this script and the Makefile have to be pretty conservative
82# about which Unix features they use.
83
84# We cannot count on Make exporting variables to commands, unless
85# they're explicitly given on the command line.
86
87# Also, we can't count on 'cp -a' or 'mkdir -p', although they're
88# pretty handy.
89
d286ee98
MP
90# I think some of the GNU documentation suggests that we shouldn't
91# rely on shell functions. However, the Bash manual seems to say that
92# they're in POSIX 1003.2, and since the build farm relies on them
93# they're probably working on most machines we really care about.
e7d29902 94
4a7cb3e8
MP
95# You cannot use "function foo {" syntax, but must instead say "foo()
96# {", or it breaks on FreeBSD.
97
571a4b26
MP
98# BSD machines tend not to have "head" or "seq".
99
6cd7888e
MP
100# You cannot do "export VAR=VALUE" all on one line; the export must be
101# separate from the assignment. (SCO SysV)
102
e7d29902 103
c36b5017
MP
104
105# STILL TO DO:
106
107# We need a good protection against tests that hang indefinitely.
108# Perhaps some combination of starting them in the background, wait,
109# and kill?
110
111# Perhaps we need a common way to cleanup tests. At the moment just
112# clobbering the directory when we're done should be enough.
113
f7ca98bd
MP
114# If any of the targets fail, then (GNU?) Make returns 2, instead of
115# the return code from the failing command. This is fine, but it
116# means that the build farm just shows "2" for failed tests, not the
117# number of tests that actually failed. For more details we might
118# need to grovel through the log files to find a line saying how many
119# failed.
120
c36b5017 121
e7d29902
MP
122set -e
123
124. "./shconfig"
125
3a4c683f 126RUNSHFLAGS='-e'
23deb0bc 127export RUNSHFLAGS
3a4c683f 128
017f22b4 129# for Solaris
30fa7724 130[ -d /usr/xpg4/bin ] && PATH="/usr/xpg4/bin/:$PATH"
017f22b4 131
30fa7724
WD
132if [ "x$loglevel" != x ] && [ "$loglevel" -gt 8 ]; then
133 if set -x; then
42e66aa2
MP
134 # If it doesn't work the first time, don't keep trying.
135 RUNSHFLAGS="$RUNSHFLAGS -x"
136 fi
3a4c683f 137fi
e7d29902
MP
138
139echo "============================================================"
140echo "$0 running in `pwd`"
141echo " rsync_bin=$rsync_bin"
142echo " srcdir=$srcdir"
143
30fa7724 144if [ -f /usr/bin/whoami ]; then
19cb6106 145 testuser=`/usr/bin/whoami`
30fa7724 146elif [ -f /usr/ucb/whoami ]; then
19cb6106 147 testuser=`/usr/ucb/whoami`
13d00101
WD
148elif [ -f /bin/whoami ]; then
149 testuser=`/bin/whoami`
19cb6106 150else
13d00101 151 testuser=`id -un 2>/dev/null || echo ${LOGNAME:-${USERNAME:-${USER:-'UNKNOWN'}}}`
19cb6106 152fi
53e1f937
MP
153
154echo " testuser=$testuser"
155echo " os=`uname -a`"
156
d1239eae 157# It must be "yes", not just nonnull
30fa7724 158if [ "x$preserve_scratch" = xyes ]; then
d1239eae
MP
159 echo " preserve_scratch=yes"
160else
161 echo " preserve_scratch=no"
162fi
163
a5df33bb
WD
164# We'll use setfacl if it's around.
165if test -f /usr/bin/setfacl || setfacl --help >/dev/null 2>&1 ; then
166 setfacl=setfacl
167else
168 setfacl=true
169fi
d1239eae 170
30fa7724 171if [ ! -f "$rsync_bin" ]; then
e7d29902
MP
172 echo "rsync_bin $rsync_bin is not a file" >&2
173 exit 2
174fi
175
30fa7724 176if [ ! -d "$srcdir" ]; then
e7d29902
MP
177 echo "srcdir $srcdir is not a directory" >&2
178 exit 2
179fi
180
78ffe478 181RSYNC="$rsync_bin"
f5d96a6f 182#RSYNC="valgrind --tool=addrcheck $rsync_bin"
e7d29902 183
78ffe478 184export rsync_bin RSYNC
e7d29902
MP
185
186skipped=0
187missing=0
188passed=0
189failed=0
190
cf72f204
MP
191# Prefix for scratch directory. We create separate directories for
192# each test case, so that they can be left behind in case of failure
193# to aid investigation.
194scratchbase="`pwd`"/testtmp
195echo " scratchbase=$scratchbase"
78ffe478 196
e7d29902
MP
197suitedir="$srcdir/testsuite"
198
3a4c683f
MP
199export scratchdir suitedir
200
cf72f204 201prep_scratch() {
b214eda4
MP
202 [ -d "$scratchdir" ] && rm -rf "$scratchdir"
203 mkdir "$scratchdir"
a5df33bb
WD
204 # Get rid of default ACLs and dir-setgid to avoid confusing some tests.
205 $setfacl -k "$scratchdir"
206 chmod g-s "$scratchdir"
cf72f204
MP
207 return 0
208}
209
c019068f
MP
210maybe_discard_scratch() {
211 [ x"$preserve_scratch" != xyes ] && [ -d "$scratchdir" ] && rm -rf "$scratchdir"
cf72f204 212 return 0
b214eda4
MP
213}
214
30fa7724 215if [ "x$whichtests" = x ]; then
c36b5017
MP
216 whichtests="*.test"
217fi
218
219for testscript in $suitedir/$whichtests
e7d29902 220do
89a9c054 221 testbase=`echo $testscript | sed -e 's!.*/!!' -e 's/.test\$//'`
cf72f204 222 scratchdir="$scratchbase.$testbase"
e7d29902 223
cf72f204 224 prep_scratch
e7d29902 225
cf72f204
MP
226 set +e
227 sh $RUNSHFLAGS "$testscript" >"$scratchdir/test.log" 2>&1
228 result=$?
229 set -e
230
c019068f
MP
231 if [ "x$always_log" = xyes -o \( $result != 0 -a $result != 77 -a $result != 78 \) ]
232 then
233 echo "----- $testbase log follows"
234 cat "$scratchdir/test.log"
235 echo "----- $testbase log ends"
53adbd7a
WD
236 if [ -f "$scratchdir/rsyncd.log" ]; then
237 echo "----- $testbase rsyncd.log follows"
238 cat "$scratchdir/rsyncd.log"
239 echo "----- $testbase rsyncd.log ends"
240 fi
c019068f
MP
241 fi
242
cf72f204
MP
243 case $result in
244 0)
f08aacf7 245 echo "PASS $testbase"
e7d29902 246 passed=`expr $passed + 1`
c019068f 247 maybe_discard_scratch
cf72f204
MP
248 ;;
249 77)
7d821932 250 # backticks will fill the whole file onto one line, which is a feature
1657be22
WD
251 whyskipped=`cat "$scratchdir/whyskipped"`
252 echo "SKIP $testbase ($whyskipped)"
cf72f204 253 skipped=`expr $skipped + 1`
c019068f 254 maybe_discard_scratch
cf72f204 255 ;;
be2f866b
MP
256 78)
257 # It failed, but we expected that. don't dump out error logs,
258 # because most users won't want to see them. But do leave
259 # the working directory around.
260 echo "XFAIL $testbase"
261 failed=`expr $failed + 1`
262 ;;
cf72f204 263 *)
f08aacf7 264 echo "FAIL $testbase"
cf72f204 265 failed=`expr $failed + 1`
30fa7724 266 if [ "x$nopersist" = xyes ]; then
cf72f204
MP
267 exit 1
268 fi
269 esac
e7d29902
MP
270done
271
272echo '------------------------------------------------------------'
273echo "----- overall results:"
274echo " $passed passed"
ec99e9da
MP
275[ "$failed" -gt 0 ] && echo " $failed failed"
276[ "$skipped" -gt 0 ] && echo " $skipped skipped"
277[ "$missing" -gt 0 ] && echo " $missing missing"
e7d29902
MP
278echo '------------------------------------------------------------'
279
32c58f06
MP
280# OK, so expr exits with 0 if the result is neither null nor zero; and
281# 1 if the expression is null or zero. This is the opposite of what
282# we want, and if we just call expr then this script will always fail,
283# because -e is set.
284
32c58f06
MP
285result=`expr $failed + $missing || true`
286echo "overall result is $result"
d2476f0d 287exit $result